+++
title = "Links for 2020-05-29"
date = 2020-05-29

[taxonomies]
tags = ["links", "spotify", "git", "commit", "emacs", "airflow", 
"open source", "rust", "contributing", "self-hosted", "vim", "wiki", "medium",
"stackoverflow", "survey"]
+++

Spotify Around the Globe, Git Commit Messages, Airflow, Emacs Bindings,
Contributing to Open Source Rust Style, Self-Hosted Git Repos, Vim Wiki, Don't
Use Medium, StackOverflow Survey Results, Problems With StackOverflow Survey.

<!-- more -->

## [Spotify Most streamed track of the day by Country](https://www.worldspotify.com/)

Curious about which song is the most played on Spotify on each country?

## [My favourite Git commit](https://dhwthompson.com/2019/my-favourite-git-commit)

A huge text for a simple one character change? Sure, why not?

I have to agree with the point being made here, although the result is a bit
too large for my taste: Write commit messages that explain why some change
had to be done, what other options where presented, and why the actual
solution was taken.

And that's how a proper commit message should be done.

## [An Introduction to Apache Airflow](https://bhavaniravi.com/blog/apache-airflow-introduction)

I have been hearign about Airflow for awhile, but what the heck it is, what it
does and things like that was something I didn't know about.

But Airflow is a data processing (ETL) framework in Python, where each task is
defined in isolation and combined afterwards in an acyclic graph.

And it is in Python.

## [Binding Emacs](https://degruchy.org/2020/05/26/binding-emacs/)

A practical guide on using Emacs keybinds.

## [Contributing to Rust](https://blog.elinvynia.com/posts/2020-05-26-contributing-to-rust.html)

Although focused on the Rust project, this is a very good personal experience
report in contributing to open source project -- in this case, a compiler. But
instead of jumping directly into code, it all started with a simple
documentation change.

The key points here are, basically: Start simple, get your feet wet and things
just will start rolling.

## [Choosing a Self-Hosted Git Service](https://www.paritybit.ca/blog/choosing-a-self-hosted-git-service)

Git != Github or Gitlab. Github and Gitlab are frontends to Git and, if you
wish, you could run a different interface on your domain.

Other optiosn presented here are: Cogs, Gitea, SourceHut, Phabricator,
Gitolite, Gitweb and cgit. Each has its own strengths and weaknesses  and they
are explored here.

I use cgit on [my repository](https://git.juliobiason.me/), although I'd
prefer to run something that generate static pages instead of something
dynamic -- I don't do that many commits that would require rendering
everything every time.

## [Personal Wiki for Vim](https://github.com/vimwiki/vimwiki)

Did you know that you can have a personal wiki using just Vim? With this
plugin, you can keep your data locally, without the need to install anything
else (besides the plugin, that is) -- and people who like Emacs forgive me,
but the format is simpler than Org-Mode (even if Org-Mode does a lot more
stuff).

## [Stop Blogging on Medium if You Care about SEO](https://pawelurbanek.com/medium-blogging-platform-seo)

I don't freaking care about SEO -- honestly, SEO is the cherry on the top of
the shit cake the internet has become -- but there are two points here that
you must pay attention: "Login wall for free articles" and "Hidden costs of
publishing on Medium" 'cause they tell you two things:

- Medium charges people for reading content on their site and
- _You_ provide the content.

So you're, basically, the one generating income for Medium. Heck, even
WordPress.com has a free tier with no paywall.

## [Stack Overflow Developer Survey 2020](https://insights.stackoverflow.com/survey/2020)

StackOverflow did a survey last year to find out which languages developers
are using, if they like it, how much they get paid, that kind of stuff.

And now, finally, the results are out.

PS: Rust is the most loved language for the 5th year in a row.

## [Stack overflow developer survey removes Clojure](https://www.reddit.com/r/Clojure/comments/gs3y4e/stack_overflow_developer_survey_removes_clojure/)

... but not everything are flowers. The Clojure subreddit found that Clojure
was not listed and even if they could fill the form with their own value,
Clojure still didn't even appear in the results.

Not only that, but on our Rust group someone asked why there were no Rust
libraries and frameworks on the list (Serde is _wildly_ used) and after that I
noticed that Glib also wasn't in the options -- and who the heck is crazy enough to
work in C (which appears in the language list) without Glib these days?

So yeah, the list is nice, but feels a lot incomplete in these days.

---

This post was built with the help of

* [Nathan DeGruchy](https://fosstodon.org/@ndegruchy)
* [HN Tooter](https://mastodon.social/@hntooter)
* [newsbot](https://mastodon.social/@newsbot)
* [Read Rust](https://botsin.space/@readrust)
* [Jake Bauer](https://social.paritybit.ca/@jbauer)
