+++
title = "Links comentados de 2020-06-11"
date = 2020-06-11

[taxonomies]
tags = ["links"]
+++

Infra-estrutura Como Código (em Python), Pong em Elm, Alan Kay e Objetos,
Paywalls, Brave, Notas, Rust do Zero, Escrevendo, 51 Conceitos Que Você
Deveria Saber, MAD em CSS, Algoritmos Mágicos.

<!-- more -->

## [Why you should try pyinfra](https://pointlessramblings.com/posts/Why_You_Should_Try_pyinfra/)

Eu tenho, por algum tempo, adiado criar um playbook em
[Ansible](https://www.ansible.com/) para configurar meu droplet na
DigitalOcean -- sem qualquer outro motivo que não seja minha preguiça -- e
agora tem esse modo em Python puro para configurar um ambiente e, com isso,
agora eu tenho dois modos de como não fazer -- de novo, porque eu sou
preguiçoso.

## [Recreating Pong for the Web with Elm](https://dev.to/bijanbwb/recreating-pong-for-the-web-with-elm-2bi8)

Existe algo profundamente satisfatório em ler um tutorial que começa bem no
começo e explica cada passo que deve ter feito.

Eu só sinto falta das parte de "Se você fizer isso, não vai funcionar/vai dar
crash".

## [Alan Kay Did Not Invent Objects](https://www.hillelwayne.com/post/alan-kay/)

Ah, eu adoro esse tipo de discussão, que se repete varias vezes -- Eu
basicamente ouvi a mesma coisa toda vez que eu ia no Meetup de Elixir daqui.

Mas o básico é: Quando Alan Kay estava falando de "design orientado a
objetos", ele estava falando da comunicação entre objetos, não sobre
encapsulamento, herança e assim por diante.

## [Problems With Paywalls](https://slatestarcodex.com/2020/06/04/problems-with-paywalls/)

Algumas das palavras no post são bastante fortes -- "Eu ficaria mais feliz em
um mundo onde os grandes jornais deixassem de existir, comparado com um mundo
onde eles existem mas seus artigos estão atrás de um paywall" -- mas o ponto
que é feito é bem real: Conteúdo atrás de um paywall usam uma ideia de "me
deixem mexer na sua imaginação/curiosidade para que você pague pelo conteúdo".
E talvez o conteúdo produzido seja feito _apenas_ para gerar curiosidade e
produz absolutamente nada de pesquisa ou conteúdo.

Ao mesmo tempo, se o conteúdo fosse bom, baseado em pesquisa e tivesse
conteúdo real que viveria por um bom tempo (e não algo que fosse interessante
somente nessa semana e seria completamente esquecido na próxima), então usar
paywalls seria válido de ser pago.

## [The Brave web browser is hijacking links, and inserting affiliate codes](https://davidgerard.co.uk/blockchain/2020/06/06/the-brave-web-browser-is-hijacking-links-and-inserting-affiliate-codes/)

Não é a primeira vez que o Brave foi pego fazendo algo moralmente questionável
com o conteúdo dos usuários. Em algum ponto, alguém começaria a se perguntar
se eles compartilhassem um link de referência com um amigo -- por exemplo,
para ter recompensas no DigitalOcean, se a outra pessoa assinasse o serviço --
e ao invés de receber a recompensa, essa fosse para o Brave para que eles
pudessem rodar seus serviços.

De uma forma, isso mostra como é difícil criar um browser nos dias atuais,
mesmo que você pegue uma base de código que já exista e faça melhorias. Mas
ações moralmente questionáveis também parecem ser a forma como a maior parte
das empresas de internet funcionam hoje em dia...

## [Zettelkasten note-taking in 10 minutes](https://blog.viktomas.com/posts/slip-box/)

Eu tenho pensando numa forma de melhorar meu fluxo de notas, de forma que o
conhecimento não seja totalmente perdido. E tem aparecido um monte dessa forma
"Zettelkasten" de fazer notas na minha timeline de tempos em tempos.

E é bom que tenha uma introdução simples exista, mesmo que eu ainda tenha que
começar a utilizar.

## [Zero To Production #1: Setup - Toolchain, IDEs, CI](https://www.lpalmieri.com/posts/2020-06-06-zero-to-production-1-setup-toolchain-ides-ci/)

Se você está interessado em Rust e não tem ideia de como começar ou para onde
ir, Luca Palmieri está escrevendo um "livro" sobre todo o processo.

## [How We Write](https://blog.griffin.sh/2020/06/05/how-we-write/)

Dicas como escrever bem. E as dicas são precisas e diretas.

## [50 Ideas That Changed My Life](https://www.perell.com/blog/50-ideas-that-changed-my-life)

Não muito como "ideias", mas mais como "conceitos".

Ainda, como toda boa lista, ela lista 51 conceitos, não apenas 50.

## [The Mad Magazine Fold-In Effect in CSS](https://thomaspark.co/2020/06/the-mad-magazine-fold-in-effect-in-css/)

Ah, a última página da MAD. Eu lembro ficar tentando várias vezes para
conseguir fazer as dobras direito, para que a imagem correta aparecesse. É
meio óbvio que, quando começamos a automatizar várias coisas, deveria ter um
modo de fazer isso.

Por outro lado, eu mantenho a mesma opinião sobre qualquer exemplo de CSS
complexo: Ok, agora centraliza o texto nesse caixa.

## [Algorithm is the Problem, Not Mark Zuckerberg](https://interconnected.blog/algorithm-is-the-problem-not-mark-zuckerberg/)

Ok, vamos discutir esse post por um ponto: Quem está mostrando que o COVID é
uma arma do governo chinês que saiu de control, racismo não é um problema e
pessoas brancas tambem sofrem racismo, e que decapitar estatuas é errado não
foi o que Zuckerberg fez, mas foi feito pelo "algoritmo".

E aqui é que está o problema: Embora Zuckerberg não tenha sido quem criou "o
algoritmo", pessoas que trabalham para ele fizeram. Ainda, "o algoritmo" não
apareceu do nada e decidiu o que você gosta, alguém foi lá e colocou isso.
Essa ideia é o que a maioria das pessoas entende errado sobre inteligência
artificial e "algoritmos": Eles não surgem do nada, alguém vai lá e coloca
essas coisa e o algoritmo simplesmente reage com o conteúdo.

Considere, por exemplo, o fato que o Google começou a marcar pessoas negras
como "gorilas" nas Fotos. Isso _não foi_ um problema com "o algoritmo"; alguém
que trabalha no Google decidiu que pessoas negras não são importantes o
suficiente para adicionar no conjunto de treinamento -- ou pior, que uma
pessoa (ou grupo de pessoas) sequer pensou que adicionar pessoas negras no
conjunto de treinamento era algo que estava faltando ou mesmo que seria válido
adicionado.

Isso não é um problema do "algoritmo", é um problema com as pessoas. Pessoas é
que estão por trás de qualquer algoritmo "mágico" que tem por aí.

E embora Zuckerberg provavelmente não tenha se envolvido com a construção
desse algoritmo, as pessoas que fizeram é que são o problema. E não o
algoritmo.

--- 

Esse post foi feito com a ajuda de

* [Adrian Cochrane](https://floss.social/@alcinnz)
* [gamer cat69](https://loves.pizza/@a_cat)
* [Hacker News 100](https://botsin.space/@hn100)
* [HN Tooter](https://mastodon.social/@hntooter)
* [newsbot](https://mastodon.social/@newsbot)

<!-- 
vim:spelllang=pt:
-->
