+++
title = "Django Design Patterns and Best Practices - Arun Ravindran"
date = 2016-07-07
updated = 2021-02-12

[taxonomies]
tags = ["books", "arun ravindran", "python", "django", "web development",
"reviews", "design patterns", "it", "stars:3", "published:2015"]
+++

[GoodReads Summary](https://www.goodreads.com/book/show/25567728-django-design-patterns-and-best-practices):
Learning how to write better Django code to build more maintainable websites
either takes a lot of experience or familiarity with various design patterns.
Filled with several idiomatic Django patterns, Django Design Patterns and
Best Practices accelerates your journey into the world of web development.

<!-- more -->

{{ stars(stars=3) }}

Although I'm not a fan of design patterns (you know, the GoF one) because
people tend replace it to proper thinking. But I do like design patterns for
languages and frameworks, because you can use something for a very long time
and still not doing it in the right way.

The book has an interesting premise: Explain a bit something, point a problem,
a solution, expand the problem and expand the solution. The problem is that
some problems seem really shoe horned to certain solutions. Also, some common
problems are not talked at all, like using CSRF with Ajax -- something the
author mentions people shouldn't do (disable CSRF) on Ajax requests.

On the other hand, the book focus on the the most recent versions (well,
almost). Instead of going in the safe road of Python 2, the book focus on
Python 3 -- and, to be honest, there isn't much difference between Django with
Python 3 and Django with Python 2.

Is not a bad book, but the really interesting things seem to be left out.
